import { LRParser } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "!jOVQPOOO_QPO'#C^OOQO'#C^'#C^QOQPOOOVQPO,58{OmQPO'#ChOuQPO1G.gOVQPO'#CbOzQPO,59SOOQO7+$R7+$ROOQO,58|,58|OOQO-E6`-E6`",
  stateData: "!S~OXOS~ORQOSPO~OZSOVQXYQX]QX~O]VOY[X~OYXO~O]VOY[a~O",
  goto: "u]PP^PPglPPPPPrQROQTSRYVVQOSVQWTRZWRUS",
  nodeNames: "⚠ Program Expr String Identifier Application",
  maxTerm: 13,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "#u~R^XY}YZ}]^}pq}rs!`xy!}yz#S|}#X}!O#^!O!P#^!Q![#^!c!}#^#R#S#^#T#o#^~!SSX~XY}YZ}]^}pq}~!cTOr!`rs!rs#O!`#O#P!w#P~!`~!wOR~~!zPO~!`~#SOZ~~#XOY~~#^O]~~#cUS~}!O#^!O!P#^!Q![#^!c!}#^#R#S#^#T#o#^",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const BSLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ['('] }
    }
});
const bslangCompletion = (sources) => {
    return BSLanguage.data.of({
        autocomplete: completeFromList([
            { label: "avg", type: "function" },
            { label: "sum", type: "function" },
            { label: "zSpread", type: "function" },
        ].concat(sources))
    });
};
function BSLANG(autocompletionSources = []) {
    return new LanguageSupport(BSLanguage, [bslangCompletion(autocompletionSources)]);
}

export { BSLANG, BSLanguage, bslangCompletion };
